///////////////////////////////////////////////////////////////////////////////
// Name:        protection.cpp
// Purpose:     Demonstration of access permissions in wxPdfDocument
// Author:      Ulrich Telle
// Modified by:
// Created:     2005-08-29
// Copyright:   (c) Ulrich Telle
// Licence:     wxWindows licence
///////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "wx/wxpdf/pdfdoc.h"

/**
* Protection
*
* This example demonstrates how you could protect your PDF document
* against copying text via cut & paste.
*/

void
protection()
{
  wxPdfDocument pdf;
  pdf.SetProtection(wxPDF_PERMISSION_PRINT);
  pdf.Open();
  pdf.AddPage();
  pdf.SetFont(_T("Arial"));
  pdf.Cell(0,10,wxString(_T("You can print me but not copy my text.")),0,1);
  pdf.SaveAsFile(_T("protection.pdf"));
}


